--- channels/chan_sip.c.orig	2010-01-05 23:16:45.657876049 +0100
+++ channels/chan_sip.c	2010-01-06 14:24:11.738975337 +0100
@@ -1229,6 +1229,17 @@
 		ast_uri_decode(str);	\
 	}	\
 
+/*!< a macro because the functionality is trivial */
+#define ast_displayname_encode(str, dst, dstlen) \
+	{ \
+		/* the specs are unclear: is the backslash allowed unquoted? */ \
+		/* make it easy on ourselves and remove the " altogether instead */ \
+		/*char tmpbuffer[dstlen];*/ \
+		/*ast_str_replace(str, "\\", "\\\\", tmpbuffer, dstlen);*/ \
+		/*ast_str_replace(tmpbuffer, "\"", "\\\"", dst, dstlen);*/ \
+		ast_str_replace(str, "\"", "''", dst, dstlen); \
+	}
+
 static int global_match_auth_username;		/*!< Match auth username if available instead of From: Default off. */
 
 static int global_relaxdtmf;		/*!< Relax DTMF */
@@ -10207,9 +10218,10 @@
 static int add_rpid(struct sip_request *req, struct sip_pvt *p)
 {
 	struct ast_str *tmp = ast_str_alloca(256);
-	char tmp2[256];
-	char *lid_num = NULL;
 	char *lid_name = NULL;
+	char lid_name_enc[256];
+	char *lid_num = NULL;
+	char lid_num_enc[256];
 	int lid_pres;
 	const char *fromdomain;
 	const char *privacy = NULL;
@@ -10232,7 +10244,9 @@
 		lid_name = lid_num;
 	fromdomain = S_OR(p->fromdomain, ast_inet_ntoa(p->ourip.sin_addr));
 
-	lid_num = ast_uri_encode(lid_num, tmp2, sizeof(tmp2), 1);
+	ast_displayname_encode(lid_name, lid_name_enc, sizeof(lid_name_enc));
+	lid_name = lid_name_enc;
+	lid_num = ast_uri_encode(lid_num, lid_num_enc, sizeof(lid_num_enc), 1);
 
 	if (ast_test_flag(&p->flags[0], SIP_SENDRPID_PAI)) {
 		if ((lid_pres & AST_PRES_RESTRICTION) != AST_PRES_ALLOWED) {
@@ -11149,9 +11163,9 @@
 		ast_string_field_set(p, fromname, n);
 
 	if (sip_cfg.pedanticsipchecking) {
-		ast_uri_encode(n, tmp_n, sizeof(tmp_n), 0);
+		ast_displayname_encode(n, tmp_n, sizeof(tmp_n));
 		n = tmp_n;
-		ast_uri_encode(l, tmp_l, sizeof(tmp_l), 0);
+		ast_uri_encode(l, tmp_l, sizeof(tmp_l), 1);
 		l = tmp_l;
 	}
 
@@ -11171,7 +11185,7 @@
 		if (!ast_strlen_zero(p->username)) {
 			n = p->username;
 			if (sip_cfg.pedanticsipchecking) {
-				ast_uri_encode(n, tmp_n, sizeof(tmp_n), 0);
+				ast_uri_encode(n, tmp_n, sizeof(tmp_n), 1);
 				n = tmp_n;
 			}
 			ast_str_append(&invite, 0, "%s@", n);
@@ -14551,6 +14565,9 @@
 
 	end--; /* move just before "<" */
 
+	/* XXX this function needs fixage:
+	 * (1) the display name doesn't require quotes
+	 * (2) if it has quotes, a quote can be escaped by \" and < and > are allowed in it */
 	if (tmp && tmp <= end) {
 		/* The quote (tmp) precedes the bracket (end+1).
 		 * Find the matching quote and return the content.
@@ -14770,7 +14787,6 @@
 	memset(calleridname, 0, sizeof(calleridname));
 	get_calleridname(from, calleridname, sizeof(calleridname));
 
-	SIP_PEDANTIC_DECODE(calleridname);
 	if (calleridname[0])
 		ast_string_field_set(p, cid_name, calleridname);
 
